# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from deepmine.speech.v1 import speech_pb2 as deepmine_dot_speech_dot_v1_dot_speech__pb2


class SpeechStub(object):
    """Service that implements DeepMine Cloud Speech API.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.Recognize = channel.unary_unary(
                '/deepmine.speech.v1.Speech/Recognize',
                request_serializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.RecognizeRequest.SerializeToString,
                response_deserializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.RecognizeResponse.FromString,
                )
        self.StreamingRecognize = channel.stream_unary(
                '/deepmine.speech.v1.Speech/StreamingRecognize',
                request_serializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.StreamingRecognizeRequest.SerializeToString,
                response_deserializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.RecognizeResponse.FromString,
                )
        self.BidiStreamingRecognize = channel.stream_stream(
                '/deepmine.speech.v1.Speech/BidiStreamingRecognize',
                request_serializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.StreamingRecognizeRequest.SerializeToString,
                response_deserializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.StreamingRecognizeResponse.FromString,
                )
        self.Align = channel.unary_unary(
                '/deepmine.speech.v1.Speech/Align',
                request_serializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.AlignmentRequest.SerializeToString,
                response_deserializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.AlignmentResponse.FromString,
                )


class SpeechServicer(object):
    """Service that implements DeepMine Cloud Speech API.
    """

    def Recognize(self, request, context):
        """Performs synchronous non-streaming speech recognition:
        receive results after all audio has been sent and processed.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def StreamingRecognize(self, request_iterator, context):
        """Performs synchronous client-to-server streaming speech recognition:
        receive results after all audio has been streamed and processed.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def BidiStreamingRecognize(self, request_iterator, context):
        """Performs synchronous bidirectional streaming speech recognition:
        receive results while sending audio.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Align(self, request, context):
        """Performs synchronous non-streaming speech alignment:
        receive results after all audio has been sent and processed.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_SpeechServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'Recognize': grpc.unary_unary_rpc_method_handler(
                    servicer.Recognize,
                    request_deserializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.RecognizeRequest.FromString,
                    response_serializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.RecognizeResponse.SerializeToString,
            ),
            'StreamingRecognize': grpc.stream_unary_rpc_method_handler(
                    servicer.StreamingRecognize,
                    request_deserializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.StreamingRecognizeRequest.FromString,
                    response_serializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.RecognizeResponse.SerializeToString,
            ),
            'BidiStreamingRecognize': grpc.stream_stream_rpc_method_handler(
                    servicer.BidiStreamingRecognize,
                    request_deserializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.StreamingRecognizeRequest.FromString,
                    response_serializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.StreamingRecognizeResponse.SerializeToString,
            ),
            'Align': grpc.unary_unary_rpc_method_handler(
                    servicer.Align,
                    request_deserializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.AlignmentRequest.FromString,
                    response_serializer=deepmine_dot_speech_dot_v1_dot_speech__pb2.AlignmentResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'deepmine.speech.v1.Speech', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class Speech(object):
    """Service that implements DeepMine Cloud Speech API.
    """

    @staticmethod
    def Recognize(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/deepmine.speech.v1.Speech/Recognize',
            deepmine_dot_speech_dot_v1_dot_speech__pb2.RecognizeRequest.SerializeToString,
            deepmine_dot_speech_dot_v1_dot_speech__pb2.RecognizeResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def StreamingRecognize(request_iterator,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.stream_unary(request_iterator, target, '/deepmine.speech.v1.Speech/StreamingRecognize',
            deepmine_dot_speech_dot_v1_dot_speech__pb2.StreamingRecognizeRequest.SerializeToString,
            deepmine_dot_speech_dot_v1_dot_speech__pb2.RecognizeResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def BidiStreamingRecognize(request_iterator,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.stream_stream(request_iterator, target, '/deepmine.speech.v1.Speech/BidiStreamingRecognize',
            deepmine_dot_speech_dot_v1_dot_speech__pb2.StreamingRecognizeRequest.SerializeToString,
            deepmine_dot_speech_dot_v1_dot_speech__pb2.StreamingRecognizeResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Align(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/deepmine.speech.v1.Speech/Align',
            deepmine_dot_speech_dot_v1_dot_speech__pb2.AlignmentRequest.SerializeToString,
            deepmine_dot_speech_dot_v1_dot_speech__pb2.AlignmentResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
