import os
import logging

if not os.path.exists('logs'):
    os.makedirs('logs')

logging.basicConfig(format='%(asctime)s :: %(levelname)s :: %(message)s', filename='logs/server.log')

logger = logging.getLogger()
logger.setLevel(logging.INFO)

GRPC_SECRET_HEADERS = {'token': 'nfEwfWr33sNT8PkkujdZK3h863vKEZUGMJULXPwn7bu5S7ScKWc92d5cD77S'}
FILE_ACCESS_ADMIN_TOKEN = 'da39a3ee5e6b4b0d3255bfef95601890afd80709'
API_ADMIN_TOKEN = 'f64b5952fb3842707a0e9d7ab77f032187215b23'

DURATION_LIMIT_SEC = 9060                       # the default is 150 * 60 = 9000 + 60 sec for margin
TIMEOUT_SEC = 9000                              # the default is 150 * 60 = 9000
MAX_MESSAGE_LENGTH = 128 * 1024 * 1024          # 128 MB
MIN_QUOTA_SEC = 5
ASR_SERVER_INTERFACE = '0.0.0.0'
SAVE_AUDIOS = False
IS_DEVELOPMENT = bool(os.environ.get('IS_DEVELOPMENT', False))
if IS_DEVELOPMENT:
    ASR_SERVER_PORT = 8445
    API_GATEWAY_BASE_URL = 'https://api2.deepmine.ir/v1'
    MAX_WORKERS = 3
    MAXIMUM_CONCURRENT_RPCS = 3
    SEC_BETWEEN_TWO_UPDATE = 10
    API_TIMEOUT_SEC = 1
    # logger.setLevel(logging.DEBUG)
else:
    ASR_SERVER_PORT = 8444
    API_GATEWAY_BASE_URL = 'https://api.deepmine.ir/v1'
    MAX_WORKERS = 32
    MAXIMUM_CONCURRENT_RPCS = 56
    SEC_BETWEEN_TWO_UPDATE = 60
    API_TIMEOUT_SEC = 4
    # logger.setLevel(logging.DEBUG)

'''
model:
audio-from-video:
Use this model for transcribing audio in video clips or that includes multiple 
speakers. For best results, provide audio recorded at 16,000Hz or greater sampling rate.
Note: This is a premium model that costs more than the standard rate.

phone-call:
Use this model for transcribing audio from a phone call. Typically, phone audio 
is recorded at 8,000Hz sampling rate.
Note: The enhanced phone model is a premium model that costs more than the standard rate.

command_and_search:
Use this model for transcribing shorter audio clips. Some examples include voice commands or voice search.

conversation:
Use this model for conversational speech (spontaneous).

dictation:
Use this model if your audio does not fit one of the previously described models. For example, 
you can use this for long-form audio recordings that feature a single speaker only. Ideally, 
the audio is high-fidelity, recorded at 16,000Hz or greater sampling rate. 
'''
AVAILABLE_MODELS = {
    'fa-IR': {
        'dictation': ('models/fa-IR/dictation-wideband', 16000),
        'conversation': ('models/fa-IR/dictation-wideband', 16000),
        'audio-from-video': ('models/fa-IR/dictation-wideband', 16000),
        'poem': ('models/fa-IR/poem-wideband', 16000),
        'phone-call': ('models/fa-IR/phone-call-narrowband', 8000),
    },
    'en': {
        'dictation': ('models/en/dictation-wideband', 16000),
        'audio-from-video': ('models/en/dictation-wideband', 16000),
        'phone-call': ('models/en/dictation-wideband', 16000),
    },
    'ar': {
        'dictation': ('models/ar/dictation-wideband', 16000),
        'quran': ('models/ar/quran-wideband', 16000),
    }
}
